﻿Imports System.Windows.Forms

Public Class Farben
    Dim tmp_Sc_Color(Form1.c_FFT_Frequenz) As Color
    Dim tmp_Dr_Color(Form1.c_FFT_Frequenz) As Color
    Dim BenutzerFarben(14) As Integer

    Private Sub Farben_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Int16
        'tmp_Sc_Color = Form1.Sc_Color
        'tmp_Dr_Color = Form1.Dr_Color

        ToolTip_Color_Uss.SetToolTip(Me.PB_Dr_Uss, "Auch Farbe für Text:" + vbCrLf + "Horizontal und" + vbCrLf + "Zeitlinie")
        visible_ToolTip(Form1.ToolTip)
        For i = 0 To Form1.c_FFT_Frequenz
            tmp_Sc_Color(i) = Form1.Sc_Color(i)
            tmp_Dr_Color(i) = Form1.Dr_Color(i)
        Next
        set_PB_Sc_BackColor()
        set_PB_Dr_BackColor()
        For i = 0 To 14
            BenutzerFarben(i) = CInt(ReadRegEntry("Colors", "CD_Custom" + CStr(i), "16777215"))
        Next
        Me.ColorDialog1.CustomColors = BenutzerFarben
    End Sub

    Public Sub visible_ToolTip(ByVal tmpToolTip As Boolean)
        ToolTip_Color_Uss.Active = tmpToolTip
    End Sub
    Private Sub PB_Sc_Hintergrund_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Sc_Hintergrund.Click
        Me.ColorDialog1.Color = tmp_Sc_Color(Form1.c_Hintergrund)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Sc_Color(Form1.c_Hintergrund) = Me.ColorDialog1.Color
            set_PB_Sc_BackColor()
        End If
    End Sub

    Private Sub set_PB_Sc_BackColor()
        DrawPB(PB_Sc_Hintergrund, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), Nothing)
        DrawPB(PB_Sc_Gitter, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Gitter))
        DrawPB(PB_Sc_Graph, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Graph))
        DrawPB(PB_Sc_Zeitlinie1, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Zeitlinie1))
        DrawPB(PB_Sc_Zeitlinie2, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Zeitlinie2))
        DrawPB(PB_Sc_Triggerpunkt, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Triggerpunkt))
        DrawPB(PB_Sc_Messpunkte, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Messpunkte))
        DrawPB(PB_Sc_Uss, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Uss))
        DrawPB(PB_Sc_FFT_Skala, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_FFT_Skala))
        DrawPB(PB_Sc_FFT_Zeitlinie, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_FFT_Zeitlinie))
        DrawPB(PB_Sc_FFT_Frequenz, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_FFT_Frequenz))
    End Sub

    Private Sub PB_Sc_Gitter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Sc_Gitter.Click
        Me.ColorDialog1.Color = tmp_Sc_Color(Form1.c_Gitter)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Sc_Color(Form1.c_Gitter) = Me.ColorDialog1.Color
            DrawPB(PB_Sc_Gitter, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Gitter))
        End If
    End Sub

    Private Sub PB_Sc_Graph_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Sc_Graph.Click
        Me.ColorDialog1.Color = tmp_Sc_Color(Form1.c_Graph)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Sc_Color(Form1.c_Graph) = Me.ColorDialog1.Color
            DrawPB(PB_Sc_Graph, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Graph))
        End If
    End Sub

    Private Sub PB_Sc_Zeitlinie1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Sc_Zeitlinie1.Click
        Me.ColorDialog1.Color = tmp_Sc_Color(Form1.c_Zeitlinie1)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Sc_Color(Form1.c_Zeitlinie1) = Me.ColorDialog1.Color
            DrawPB(PB_Sc_Zeitlinie1, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Zeitlinie1))
        End If
    End Sub

    Private Sub PB_Sc_Zeitlinie2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Sc_Zeitlinie2.Click
        Me.ColorDialog1.Color = tmp_Sc_Color(Form1.c_Zeitlinie2)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Sc_Color(Form1.c_Zeitlinie2) = Me.ColorDialog1.Color
            DrawPB(PB_Sc_Zeitlinie2, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Zeitlinie2))
        End If
    End Sub

    Private Sub PB_Sc_Triggerpunkt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Sc_Triggerpunkt.Click
        Me.ColorDialog1.Color = tmp_Sc_Color(Form1.c_Triggerpunkt)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Sc_Color(Form1.c_Triggerpunkt) = Me.ColorDialog1.Color
            DrawPB(PB_Sc_Triggerpunkt, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Triggerpunkt))
        End If
    End Sub

    Private Sub PB_Sc_Messpunkte_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Sc_Messpunkte.Click
        Me.ColorDialog1.Color = tmp_Sc_Color(Form1.c_Messpunkte)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Sc_Color(Form1.c_Messpunkte) = Me.ColorDialog1.Color
            DrawPB(PB_Sc_Messpunkte, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Messpunkte))
        End If
    End Sub

    Private Sub PB_Sc_Uss_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Sc_Uss.Click
        Me.ColorDialog1.Color = tmp_Sc_Color(Form1.c_Uss)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Sc_Color(Form1.c_Uss) = Me.ColorDialog1.Color
            DrawPB(PB_Sc_Uss, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_Uss))
        End If
    End Sub

    Private Sub PB_Sc_FFT_Skala_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Sc_FFT_Skala.Click
        Me.ColorDialog1.Color = tmp_Sc_Color(Form1.c_FFT_Skala)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Sc_Color(Form1.c_FFT_Skala) = Me.ColorDialog1.Color
            DrawPB(PB_Sc_FFT_Skala, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_FFT_Skala))
        End If
    End Sub

    Private Sub PB_Sc_FFT_Zeitlinie_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Sc_FFT_Zeitlinie.Click
        Me.ColorDialog1.Color = tmp_Sc_Color(Form1.c_FFT_Zeitlinie)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Sc_Color(Form1.c_FFT_Zeitlinie) = Me.ColorDialog1.Color
            DrawPB(PB_Sc_FFT_Zeitlinie, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_FFT_Zeitlinie))
        End If
    End Sub

    Private Sub PB_Sc_FFT_Frequenz_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Sc_FFT_Frequenz.Click
        Me.ColorDialog1.Color = tmp_Sc_Color(Form1.c_FFT_Frequenz)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Sc_Color(Form1.c_FFT_Frequenz) = Me.ColorDialog1.Color
            DrawPB(PB_Sc_FFT_Frequenz, New SolidBrush(tmp_Sc_Color(Form1.c_Hintergrund)), tmp_Sc_Color(Form1.c_FFT_Frequenz))
        End If
    End Sub

    Private Sub PB_Dr_Hintergrund_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Dr_Hintergrund.Click
        Me.ColorDialog1.Color = tmp_Dr_Color(Form1.c_Hintergrund)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Dr_Color(Form1.c_Hintergrund) = Me.ColorDialog1.Color
            set_PB_Dr_BackColor()
        End If
    End Sub

    Private Sub set_PB_Dr_BackColor()
        DrawPB(PB_Dr_Hintergrund, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), Nothing)
        DrawPB(PB_Dr_Gitter, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Gitter))
        DrawPB(PB_Dr_Graph, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Graph))
        DrawPB(PB_Dr_Zeitlinie1, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Zeitlinie1))
        DrawPB(PB_Dr_Zeitlinie2, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Zeitlinie2))
        DrawPB(PB_Dr_Triggerpunkt, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Triggerpunkt))
        DrawPB(PB_Dr_Messpunkte, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Messpunkte))
        DrawPB(PB_Dr_Uss, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Uss))
        DrawPB(PB_Dr_FFT_Skala, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_FFT_Skala))
        DrawPB(PB_Dr_FFT_Zeitlinie, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_FFT_Zeitlinie))
        DrawPB(PB_Dr_FFT_Frequenz, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_FFT_Frequenz))
    End Sub

    Private Sub PB_Dr_Gitter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Dr_Gitter.Click
        Me.ColorDialog1.Color = tmp_Dr_Color(Form1.c_Gitter)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Dr_Color(Form1.c_Gitter) = Me.ColorDialog1.Color
            DrawPB(PB_Dr_Gitter, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Gitter))
        End If
    End Sub

    Private Sub PB_Dr_Graph_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Dr_Graph.Click
        Me.ColorDialog1.Color = tmp_Dr_Color(Form1.c_Graph)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Dr_Color(Form1.c_Graph) = Me.ColorDialog1.Color
            DrawPB(PB_Dr_Graph, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Graph))
        End If
    End Sub

    Private Sub PB_Dr_Zeitlinie1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Dr_Zeitlinie1.Click
        Me.ColorDialog1.Color = tmp_Dr_Color(Form1.c_Zeitlinie1)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Dr_Color(Form1.c_Zeitlinie1) = Me.ColorDialog1.Color
            DrawPB(PB_Dr_Zeitlinie1, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Zeitlinie1))
        End If
    End Sub

    Private Sub PB_Dr_Zeitlinie2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Dr_Zeitlinie2.Click
        Me.ColorDialog1.Color = tmp_Dr_Color(Form1.c_Zeitlinie2)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Dr_Color(Form1.c_Zeitlinie2) = Me.ColorDialog1.Color
            DrawPB(PB_Dr_Zeitlinie2, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Zeitlinie2))
        End If
    End Sub

    Private Sub PB_Dr_Triggerpunkt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Dr_Triggerpunkt.Click
        Me.ColorDialog1.Color = tmp_Dr_Color(Form1.c_Triggerpunkt)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Dr_Color(Form1.c_Triggerpunkt) = Me.ColorDialog1.Color
            DrawPB(PB_Dr_Triggerpunkt, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Triggerpunkt))
        End If
    End Sub

    Private Sub PB_Dr_Messpunkte_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Dr_Messpunkte.Click
        Me.ColorDialog1.Color = tmp_Dr_Color(Form1.c_Messpunkte)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Dr_Color(Form1.c_Messpunkte) = Me.ColorDialog1.Color
            DrawPB(PB_Dr_Messpunkte, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Messpunkte))
        End If
    End Sub

    Private Sub PB_Dr_Uss_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Dr_Uss.Click
        Me.ColorDialog1.Color = tmp_Dr_Color(Form1.c_Uss)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Dr_Color(Form1.c_Uss) = Me.ColorDialog1.Color
            DrawPB(PB_Dr_Uss, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_Uss))
        End If
    End Sub

    Private Sub PB_Dr_FFT_Skala_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Dr_FFT_Skala.Click
        Me.ColorDialog1.Color = tmp_Dr_Color(Form1.c_FFT_Skala)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Dr_Color(Form1.c_FFT_Skala) = Me.ColorDialog1.Color
            DrawPB(PB_Dr_FFT_Skala, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_FFT_Skala))
        End If
    End Sub

    Private Sub PB_Dr_FFT_Zeitlinie_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Dr_FFT_Zeitlinie.Click
        Me.ColorDialog1.Color = tmp_Dr_Color(Form1.c_FFT_Zeitlinie)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Dr_Color(Form1.c_FFT_Zeitlinie) = Me.ColorDialog1.Color
            DrawPB(PB_Dr_FFT_Zeitlinie, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_FFT_Zeitlinie))
        End If
    End Sub

    Private Sub PB_Dr_FFT_Frequenz_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB_Dr_FFT_Frequenz.Click
        Me.ColorDialog1.Color = tmp_Dr_Color(Form1.c_FFT_Frequenz)
        If (Me.ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            tmp_Dr_Color(Form1.c_FFT_Frequenz) = Me.ColorDialog1.Color
            DrawPB(PB_Dr_FFT_Frequenz, New SolidBrush(tmp_Dr_Color(Form1.c_Hintergrund)), tmp_Dr_Color(Form1.c_FFT_Frequenz))
        End If
    End Sub

    Private Sub Accept()
        Dim i As Int16
        For i = 0 To Form1.c_ColorEnd
            Form1.Sc_Color(i) = tmp_Sc_Color(i)
            Form1.Dr_Color(i) = tmp_Dr_Color(i)
        Next
    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Dim i As Int16
        Accept()
        For i = 0 To Form1.c_ColorEnd
            WriteRegColor("Colors", "Sc_Color" + CStr(i), tmp_Sc_Color(i))
            WriteRegColor("Colors", "Dr_Color" + CStr(i), tmp_Dr_Color(i))
        Next

        BenutzerFarben = Me.ColorDialog1.CustomColors
        For i = 0 To 14
            WriteRegEntry("Colors", "CD_Custom" + CStr(i), BenutzerFarben(i))
        Next

        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Form1.Read_Colors()
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub Accept_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Accept_Button.Click
        Accept()
    End Sub

    Private Sub DrawPB(ByVal PBx As PictureBox, ByVal BackBrush As SolidBrush, ByVal LineColor As Color)
        Dim g As Graphics
        Dim DrawBitmap As Bitmap
        Dim myPen As Pen

        DrawBitmap = New Bitmap(PBx.Width, PBx.Height)
        PBx.Image = DrawBitmap
        g = Graphics.FromImage(DrawBitmap)
        g.FillRectangle(BackBrush, 0, 0, PBx.Width, PBx.Height)
        If LineColor <> Nothing Then
            myPen = New Pen(LineColor, 5)
            g.DrawLine(myPen, 0, PBx.Height \ 2 - 3, PBx.Width - 5, PBx.Height \ 2 - 3)
            myPen.Dispose()
        End If
    End Sub

End Class
