Imports System.Math

Public Class Form1
    Public c_Hintergrund = 0
    Public c_Gitter = 1
    Public c_Graph = 2
    Public c_Zeitlinie1 = 3
    Public c_Zeitlinie2 = 4
    Public c_Triggerpunkt = 5
    Public c_Messpunkte = 6
    Public c_Uss = 7
    Public c_FFT_Skala = 8
    Public c_FFT_Zeitlinie = 9
    Public c_FFT_Frequenz = 10
    Public c_ColorEnd = 10
    Public Sc_Color() As Color = {Color.ForestGreen, Color.DarkGray, Color.Black, Color.DarkBlue, Color.DarkRed, Color.DarkRed, Color.Yellow, Color.Black, Color.Black, Color.DarkBlue, Color.Yellow}
    Public Dr_Color() As Color = {Color.LightGray, Color.DarkGray, Color.Black, Color.Black, Color.Black, Color.Black, Color.Gray, Color.Black, Color.Black, Color.Black, Color.Black}

    Const exit_end = 100           ' verhindert Endlosschleife bei While (SerialPort1.BytesToRead = 0......
    Const div_y = 10
    Const div_x = 12
    Dim box_rand_y As Integer = 0
    Const box_delta_y = 40
    Const box_delta_x = 40
    Const acc_border = 12
    Const TimeBase = 20            ' 20ns durch 50MHz Quarz
    Dim Teiler As New ConstIntegerArray(New Integer() {1, 32, 256, 2}) ' Hardware-Teiler eingestellt durch DIV_teiler 0 bis 3
    Dim Const_Time_Bytes_Print As New ConstIntegerArray(New Integer() {60, 150, 300, 600, 500, 600, 600, 600, 469, 625, 586, 625, 469, 586, 558, 601})
    Dim Const_DIV_loop As New ConstIntegerArray(New Integer() {0, 0, 0, 0, 2, 4, 9, 24, 1, 2, 7, 14, 4, 9, 20, 38})
    Dim Const_DIV_teiler As New ConstIntegerArray(New Integer() {0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2})
    Public DIV_loop As Decimal
    Public DIV_teiler As Decimal
    Public Const RAM_size = 32768
    Public Data(RAM_size + 1024) ' gre Index abgeleitet von SerialPort1.ReadBuffersize
    Const c_RX_Count = 650 'Public
    Dim RX_Count = c_RX_Count - 1
    Const TL_off = 0 'TimeLines_off
    Const TL_1 = 1 'TimeLine_1
    Const TL_2 = 2 'TimeLine_2
    Public Const TL_3 = 3 'TimeLine_3 fr fft eigene TimeLine genommen um trigger_delay nicht wieder rausnehmen zu mssen
    ' eine vierte Zeilinie => TL_4=4 definieren; Dim TimeLine(TL_4) und
    ' z.B: DrawCursorLine(grafx.Graphics, TimeLine(TL_4), myPen7)
    Public TimeLineData(TL_3) As Decimal 'Feld(0)0 - moving = False, sonst Zeiger auf Feldx (ZeitLinie1, ZeitLinie2...)
    Dim visibleTimeL As Boolean
    Dim visibleMessPkt As Boolean
    Delegate Sub SetTextCallback(ByVal x As Decimal)
    Public Time_Bytes_Print As Integer = 1
    Dim Time_div_set As Byte
    Dim varDIV_loop As Decimal = 1
    Dim TP_DIV_loop As Decimal = 1
    Dim accelerate As Boolean = False
    Dim acc_delay As Byte = 0
    Dim TrigPos As Boolean
    Public trigoff As Byte
    Dim trigger_delay As Byte
    Dim trigger_prev As Boolean
    Dim trigger_ram As Boolean
    Dim trigger_vz As Integer = -1
    Public ToolTip As Boolean
    Dim sync_plus As Boolean
    Dim Switch_hold As Boolean
    Dim hold As Boolean
    Dim readDataHold As Boolean = False
    Dim TrPoint As Integer
    Public Uss_Visible As Boolean = True
    Public Uss_corr As Decimal = 22.8
    Public UssGr_corr As Decimal = 1.175
    Dim Y0_line As Decimal
    Dim delta_x1 As Decimal
    '======================================
    Public fft_on As Boolean = False
    Public fft_exp_sampels As Byte  '0=512, 1=1024, 2=2048, 3=4096, 4=8192 und 5=16384 mglich
    Dim fa As Decimal 'Abtastfrequenz
    Dim fft_Dehnen_Value As Integer

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ports() As String
        Dim port As String
        Dim count As Integer

        visibleTimeL = False
        TimeLineData(0) = TL_off
        TimeLineData(TL_1) = 0
        TimeLineData(TL_2) = 0
        TimeLineData(TL_3) = 0
        Time_Bytes_Print = 100

        Read_Colors()
        Write_Spectrum()
        trigger_ram = True
        set_TrMode()
        fft_on = False
        'Com Ports suchen und in Liste eintragen
        ports = System.IO.Ports.SerialPort.GetPortNames
        ToolStripComboBox_ComPort.Text = ports(0)
        For Each port In ports
            ToolStripComboBox_ComPort.Items.Add(port)
        Next port
        txt_ToolTip_RAM()
        txt_ToolTip_slow()
        Timer1.Interval = ReadRegEntry("Options", "Timer-Interval", 170)
        ToolStripComboBox_ComPort.Text = ReadRegEntry("Options", "Port", ports(0))
        fft_exp_sampels = ReadRegEntry("Options", "FFT-exp", 0)
        Uss_corr = ReadRegEntry("Options", "Uss-corr", Uss_corr)
        UssGr_corr = ReadRegEntry("Options", "UssGraph-corr", UssGr_corr)
        ToolTip = ReadRegEntry("Options", "ToolTip", True)
        Time_div_set = ReadRegEntry("Settings", "Time-div", 12)
        TrackBar_Trigger.Value = ReadRegEntry("Settings", "Triggervalue", 170)
        TrackBar_YPos.Value = ReadRegEntry("Settings", "Y-Position", 128)

        trigoff = TrackBar_Trigger.Value
        visible_ToolTip(ToolTip)
        Y0_line = 255 - (255 / (UssGr_corr * 2))
        For count = 0 To c_RX_Count
            Data(count) = Y0_line
        Next
        If Uss_corr = 0 Then
            Uss_Visible = False
            Uss_corr = 1
        End If
        SerialPort1.PortName() = ToolStripComboBox_ComPort.Text

        fft_init()
        Time_print()
        Timer1.Start()
    End Sub

    Public Sub Read_Colors()
        Dim i As Int16
        For i = 0 To c_ColorEnd
            Sc_Color(i) = ReadRegColor("Colors", "Sc_Color" + CStr(i), Sc_Color(i))
            Dr_Color(i) = ReadRegColor("Colors", "Dr_Color" + CStr(i), Dr_Color(i))
        Next
    End Sub

    Public Sub fft_init()
        Nfft = 512 << fft_exp_sampels ' 512 * 2 ^ fft_exp_sampels
        N05fft = Nfft \ 2
        'TrackBar_fft_Dehnen.Maximum = 1 << fft_exp_sampels
        TrackBar_fft_Dehnen.Maximum = 1 << (fft_exp_sampels + 1)
        TrackBar_fft_Dehnen.Value = TrackBar_fft_Dehnen.Maximum
        fft_Dehnen_Value = 1
    End Sub

    Private Sub PortOeffnen_MenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PortOeffnen_MenuItem.Click
        'Button COM Port Open/Close
        If SerialPort1.IsOpen = False Then
            Try
                SerialPort1.Open()
            Catch
                MsgBox("Error open " + ToolStripComboBox_ComPort.Text)
                Exit Sub
            End Try
            PortOeffnen_MenuItem.Text = "Port schlieen"
            ToolStripComboBox_ComPort.Enabled = False
            Time_print()
            set_AC()                ' AC
            set_triggeroff()
            set_trigfl()            ' positive Flanke
            TrackBar_Trigger_delay.Value = 0     ' keine Triggerverzgerung
            set_trigger_delay()
            sync_plus = True        ' wird gleich zurckgeschaltet, damit nicht mit sync_plus (gelb) anfngt
            set_trigger_del()       ' Schalter auf Triggerverzgerung
            sync_plus = False       ' sonst msste im ungnstigsten Fall Button 2 mal bettigt werden
            Switch_hold = True      ' wird durch set_hold auf False geschaltet - repetierend
            set_hold()
            set_y_pos()             ' Y-Position Offset
            trigger_ram = Not (trigger_ram)
            set_TrMode()            ' ansonsten funktioniert manchmal Triggerdelay nicht nach ffnen
            accelerate = True
            set_acc()
            GroupBox_TriggerDelay.Visible = trigger_ram
            fft_on = Not (fft_on)   ' aktuellen Zustand beibehalten, set_fft repetierend
            set_fft()
        Else
            Switch_hold = False
            PortOeffnen_MenuItem.Text = "Port ffnen"
            ToolStripComboBox_ComPort.Enabled = True
            SerialPort1.Close()
            Button_AC.BackColor = SystemColors.Control
            Button_DC.BackColor = SystemColors.Control
            Button_Tr_pos.BackColor = SystemColors.Control
            Button_Tr_neg.BackColor = SystemColors.Control
            Button_Tr_prev.BackColor = SystemColors.Control
            Button_Tr_prev.ForeColor = SystemColors.ControlText
            Button_Tr_delay.BackColor = SystemColors.Control
            Button_Tr_delay.ForeColor = SystemColors.ControlText
            Button_Hold.BackColor = SystemColors.Control
            GroupBox_TriggerDelay.ForeColor = SystemColors.ControlText
        End If
    End Sub

    Private Sub ToolStripComboBox_ComPort_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripComboBox_ComPort.SelectedIndexChanged
        WriteRegEntry("Options", "Port", ToolStripComboBox_ComPort.Text)
        SerialPort1.PortName() = ToolStripComboBox_ComPort.Text
    End Sub

    Private Sub Vorschau_MenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Vorschau_MenuItem.Click
        PrintPreviewDialog1.Document = PrintDocument1
        If PrintPreviewDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            PrintDocument1.Print()
        End If
    End Sub

    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Const Seitenrand_y = 100
        Dim grafx As Graphics = e.Graphics
        Dim drawFont As New Font("Microsoft Sans Serif", 12)
        Dim TextSize As New System.Drawing.SizeF
        Dim myPen4 As New Pen(Dr_Color(c_Zeitlinie2), 2)
        Dim myPen5 As New Pen(Dr_Color(c_Zeitlinie1), 2)
        Dim pb_x As Integer
        Dim pb_y As Integer

        pb_x = 650 - (2 * box_delta_x)
        pb_y = 520 - (2 * box_delta_y)

        grafx.DrawString("Horizontal:", drawFont, New SolidBrush(Dr_Color(c_Uss)), box_delta_x - 5, 70)
        TextSize = grafx.MeasureString("Horizontal", drawFont)
        grafx.DrawString(TextBox_Horizomtal.Text, drawFont, New SolidBrush(Dr_Color(c_Uss)), box_delta_x + TextSize.Width + 5, 70)
        If visibleTimeL Then
            grafx.DrawString("Zeitlinie:", drawFont, New SolidBrush(Dr_Color(c_Uss)), box_delta_x - 5, 90)
            If Not (fft_on) Then
                grafx.DrawString(TextBox_Cu_Zeit.Text, drawFont, New SolidBrush(Dr_Color(c_Uss)), box_delta_x + TextSize.Width + 5, 90)
                TextSize.Width = TextSize.Width + grafx.MeasureString(TextBox_Cu_Frequenz.Text, drawFont).Width
            End If
            grafx.DrawString(TextBox_Cu_Frequenz.Text, drawFont, New SolidBrush(Dr_Color(c_Uss)), box_delta_x + TextSize.Width + 5, 90)
        End If
        grafx.FillRectangle(New SolidBrush(Dr_Color(c_Hintergrund)), box_delta_x, box_delta_y + Seitenrand_y, pb_x, pb_y)
        draw_Spectrum(grafx, Dr_Color, pb_x, pb_y, Seitenrand_y)

        If Not (fft_on) And visibleTimeL Then 'Cursor-Linien zeichnen
            DrawCursorLine(grafx, pb_y, TimeLineData(TL_2), pb_x, delta_x1, Seitenrand_y, myPen4)
            DrawCursorLine(grafx, pb_y, TimeLineData(TL_1), pb_x, delta_x1, Seitenrand_y, myPen5)
        End If

        myPen4.Dispose()
        myPen5.Dispose()
    End Sub

    Private Sub Write_Spectrum()
        Const Seitenrand_y = 0
        Dim myGrafik As Graphics
        Dim grafx As BufferedGraphics
        Dim context As BufferedGraphicsContext
        Dim myPen4 As New Pen(Sc_Color(c_Zeitlinie2), 2)
        Dim myPen5 As New Pen(Sc_Color(c_Zeitlinie1), 2)
        Dim pb_x As Decimal
        Dim pb_y As Decimal

        context = BufferedGraphicsManager.Current
        context.MaximumBuffer = New Size(PictureBox1.Width + 1, PictureBox1.Height + 1)
        grafx = context.Allocate(PictureBox1.CreateGraphics(), New Rectangle(0, 0, PictureBox1.Width, PictureBox1.Height))

        'clear buffer
        grafx.Graphics.FillRectangle(New SolidBrush(Sc_Color(c_Hintergrund)), 0, 0, PictureBox1.Width, PictureBox1.Height)
        myGrafik = Graphics.FromHwnd(hwnd:=PictureBox1().Handle)

        pb_x = PictureBox1.Width - (2 * box_delta_x)
        pb_y = PictureBox1.Height - (2 * box_delta_y)

        draw_Spectrum(grafx.Graphics, Sc_Color, pb_x, pb_y, Seitenrand_y)

        If Not (fft_on) And visibleTimeL Then 'Cursor-Linien zeichnen
            DrawCursorLine(grafx.Graphics, pb_y, TimeLineData(TL_2), pb_x, delta_x1, Seitenrand_y, myPen4)
            DrawCursorLine(grafx.Graphics, pb_y, TimeLineData(TL_1), pb_x, delta_x1, Seitenrand_y, myPen5)
        End If

        'display buffer
        grafx.Render(myGrafik)
        grafx.Dispose()
        myPen4.Dispose()
        myPen5.Dispose()
    End Sub

    Private Sub draw_Spectrum(ByVal g As Graphics, ByVal mColor() As Color, ByVal pb_x As Decimal, ByVal pb_y As Decimal, ByVal Seitenrand_y As Integer)
        Dim myPen1 As New Pen(mColor(c_Graph), 2)
        Dim myPen2 As New Pen(mColor(c_Gitter), 1)
        Dim myPen3 As New Pen(mColor(c_Gitter), 3)
        'Dim myPen4 As New Pen(mColor(c_Zeitlinie2), 2)
        'Dim myPen5 As New Pen(mColor(c_Zeitlinie1), 2)
        Dim myPen6 As New Pen(mColor(c_Messpunkte), 2)
        Dim myPen7 As New Pen(mColor(c_FFT_Zeitlinie), 2)

        Dim delta_y As Decimal
        Dim delta_x As Decimal
        Dim delta_y1 As Decimal
        'Dim delta_x1 As Decimal

        Dim U_low As Decimal
        Dim U_high As Decimal
        Dim Uss As Decimal
        Dim i As Decimal
        Dim count As Decimal
        Dim f1 As Decimal
        Dim fs As String
        Dim drawFont As New Font("Microsoft Sans Serif", 8)
        Dim drawFontUSS As New Font("Microsoft Sans Serif", 12)
        Dim TextSize As New System.Drawing.SizeF
        Dim DimResult As String = ""

        delta_y = pb_y / div_y
        delta_x = pb_x / div_x

        '====================================================
        If fft_on Then

            'paint horizontal lines
            For count = 0 To div_y
                g.DrawLine(myPen2, box_delta_x, (delta_y * count) + box_delta_y + Seitenrand_y, pb_x + box_delta_x, (delta_y * count) + box_delta_y + Seitenrand_y)
            Next

            'paint vertical lines
            'delta_x = pb_x / div_x

            For count = 0 To div_x
                g.DrawLine(myPen2, (delta_x * count) + box_delta_x, box_delta_y + Seitenrand_y, (delta_x * count) + box_delta_x, pb_y + box_delta_y + Seitenrand_y)

                fs = xAchse(df * HScrollBar1.Value + fn / (div_x * fft_Dehnen_Value) * count, fn, DimResult)
                TextSize = g.MeasureString(fs, drawFont)
                If count < div_x Then
                    g.DrawString(fs, drawFont, New SolidBrush(mColor(c_FFT_Skala)), (delta_x * count) + box_delta_x - TextSize.Width / 2, pb_y + box_delta_y + Seitenrand_y + 2)
                Else
                    g.DrawString(fs + DimResult, drawFont, New SolidBrush(mColor(c_FFT_Skala)), (delta_x * count) + box_delta_x - 6 - TextSize.Width / 2, pb_y + box_delta_y + Seitenrand_y + 2)
                End If
            Next
            If maxvalue = 0 Then maxvalue = 1

            Calculate_fft()

            delta_y1 = pb_y / maxvalue
            delta_x1 = pb_x * fft_Dehnen_Value / N05fft

            f1 = df * smax
            TextSize = g.MeasureString(FormatFrequenz(f1), drawFont)
            g.DrawString(FormatFrequenz(f1), drawFont, New SolidBrush(mColor(c_FFT_Frequenz)), CInt((delta_x1 * (smax - HScrollBar1.Value)) + box_delta_x - TextSize.Width / 2), pb_y + box_delta_y + Seitenrand_y + TextSize.Height + 2)
            'paint data line
            For count = 1 To N05fft \ fft_Dehnen_Value
                i = count + HScrollBar1.Value
                g.DrawLine(myPen1, (count * delta_x1) - delta_x1 + box_delta_x, pb_y - DatFFT(i - 1) * delta_y1 + box_delta_y + Seitenrand_y, (count * delta_x1) + box_delta_x, pb_y - DatFFT(i) * delta_y1 + box_delta_y + Seitenrand_y)
                If visibleMessPkt Then
                    g.DrawEllipse(myPen6, (count * delta_x1) - delta_x1 + box_delta_x, pb_y - DatFFT(i - 1) * delta_y1 + box_delta_y + Seitenrand_y, 1, 1)
                End If
            Next

            If visibleTimeL Then DrawCursorLine(g, pb_y, TimeLineData(TL_3), pb_x, delta_x1, +Seitenrand_y, myPen7) 'Cursor-Linien zeichnen
        Else
            '====================================================

            'paint horizontal lines
            For count = 0 To div_y
                If count = div_y / 2 Then
                    g.DrawLine(myPen3, box_delta_x, (delta_y * count) + box_delta_y + Seitenrand_y, pb_x + box_delta_x, (delta_y * count) + box_delta_y + Seitenrand_y)
                Else
                    g.DrawLine(myPen2, box_delta_x, (delta_y * count) + box_delta_y + Seitenrand_y, pb_x + box_delta_x, (delta_y * count) + box_delta_y + Seitenrand_y)
                End If
            Next

            'paint vertical lines
            For count = 0 To div_x
                If count = div_x / 2 Then
                    g.DrawLine(myPen3, (delta_x * count) + box_delta_x, box_delta_y + Seitenrand_y, (delta_x * count) + box_delta_x, pb_y + box_delta_y + Seitenrand_y)
                Else
                    g.DrawLine(myPen2, (delta_x * count) + box_delta_x, box_delta_y + Seitenrand_y, (delta_x * count) + box_delta_x, pb_y + box_delta_y + Seitenrand_y)
                End If
            Next

            delta_y1 = pb_y / 255              'AD-Wandler max. Digitalwert
            delta_x1 = pb_x / Time_Bytes_Print 'RX_DATA

            U_high = Data(0) ' sonst wird erster Wert durch count ausgelassen
            U_low = U_high

            'paint data line
            For count = 1 To Time_Bytes_Print 'RX_DATA 
                i = count * varDIV_loop + HScrollBar1.Value
                g.DrawLine(myPen1, (count * delta_x1) - delta_x1 + box_delta_x, (255 - Data(i - varDIV_loop)) * UssGr_corr * delta_y1 + box_delta_y + Seitenrand_y, (count * delta_x1) + box_delta_x, (255 - Data(i)) * UssGr_corr * delta_y1 + box_delta_y + Seitenrand_y)
                If visibleMessPkt Then
                    g.DrawEllipse(myPen6, (count * delta_x1) - delta_x1 + box_delta_x, (255 - Data(i - varDIV_loop)) * UssGr_corr * delta_y1 + box_delta_y + Seitenrand_y, 1, 1)
                End If
                If (U_high < Data(i)) Then
                    U_high = Data(i)
                ElseIf (U_low > Data(i)) Then
                    U_low = Data(i)
                End If
            Next

            DrawTriggerPoint(g, pb_x, delta_y1, Seitenrand_y, delta_x1, mColor(c_Triggerpunkt))

            'If visibleTimeL Then 'Cursor-Linien zeichnen
            'DrawCursorLine(g, pb_y, TimeLineData(TL_2), pb_x, delta_x1, myPen4)
            'DrawCursorLine(g, pb_y, TimeLineData(TL_1), pb_x, delta_x1, myPen5)
            'End If

            If Uss_Visible Then
                Uss = (U_high - U_low) / Uss_corr
                g.DrawString("Uss " + Format(Uss, "0.0 V"), drawFontUSS, New SolidBrush(mColor(c_Uss)), box_delta_x - 5, box_delta_y \ 4 + Seitenrand_y)
            End If
        End If
        myPen1.Dispose()
        myPen2.Dispose()
        myPen3.Dispose()
        'myPen4.Dispose()
        'myPen5.Dispose()
        myPen6.Dispose()
        myPen7.Dispose()
    End Sub

    Private Sub DrawTriggerPoint(ByVal graph As Graphics, ByVal pb_x As Decimal, ByVal delta_y As Decimal, ByVal Seitenrand_y As Integer, ByVal deltaX1 As Decimal, ByVal Trp_Color As Color)
        Dim myPenTPoint As New Pen(Trp_Color, 3)
        Dim myPenTDreieck As New Pen(Trp_Color, 2)
        Dim TriggerPoint As Decimal = (TrPoint - HScrollBar1.Value) * deltaX1 / TP_DIV_loop
        If (TriggerPoint > 0) Then
            If (TriggerPoint <= pb_x) Then
                graph.DrawEllipse(myPenTPoint, TriggerPoint + box_delta_x, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y, 2, 2)
            Else
                'wenn Cursorlinien mit z.B. Scrollbar auerhalb des sichtbaren, so wenigsten Vierecke zum Zurckholen darstellen 
                graph.DrawLine(myPenTDreieck, pb_x + box_delta_x + 1, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y, pb_x + box_delta_x - 5, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y + 4)
                graph.DrawLine(myPenTDreieck, pb_x + box_delta_x + 1, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y, pb_x + box_delta_x - 5, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y - 4)
                graph.DrawLine(myPenTDreieck, pb_x + box_delta_x - 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y + 4, pb_x + box_delta_x - 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y - 4)
            End If
        Else
            graph.DrawLine(myPenTDreieck, box_delta_x - 2, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y, box_delta_x + 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y + 4)
            graph.DrawLine(myPenTDreieck, box_delta_x - 2, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y, box_delta_x + 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y - 4)
            graph.DrawLine(myPenTDreieck, box_delta_x + 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y + 4, box_delta_x + 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + Seitenrand_y - 4)
        End If
        myPenTPoint.Dispose()
        myPenTDreieck.Dispose()
    End Sub

    Private Sub DrawCursorLine(ByVal graph As Graphics, ByVal PB_Height As Int16, ByVal TL As Decimal, ByVal pb_x As Decimal, ByVal deltaX1 As Decimal, ByVal Seitenrand_y As Integer, ByVal myPen As Pen)
        Dim TimeLine As Decimal = (TL - HScrollBar1.Value) * deltaX1 / varDIV_loop
        If (TimeLine >= 0) Then
            If (TimeLine <= pb_x + deltaX1) Then
                Dim startVert As New Point(TimeLine + box_delta_x, box_delta_y + Seitenrand_y)
                Dim endVert As New Point(TimeLine + box_delta_x, PB_Height + box_delta_y + Seitenrand_y + 2)
                graph.DrawRectangle(myPen, TimeLine - 3 + box_delta_x, box_delta_y + Seitenrand_y - 5, 5, 5)
                graph.DrawLine(myPen, startVert, endVert)
            Else
                'wenn Cursorlinien mit z.B. Scrollbar auerhalb des sichtbaren, so wenigstens Vierecke zum Zurckholen darstellen 
                graph.DrawRectangle(myPen, pb_x + box_delta_x - 3, box_delta_y + Seitenrand_y - 5, 5, 5)
            End If
        Else
            graph.DrawRectangle(myPen, box_delta_x - 3, box_delta_y + Seitenrand_y - 5, 5, 5)
        End If
    End Sub

    Private Sub PictureBox1_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDoubleClick
        Dim TL_x As Byte

        If visibleTimeL And e.Button = Windows.Forms.MouseButtons.Left Then
            If fft_on Then
                TL_x = TL_3
            Else
                TL_x = TL_1
            End If
            If Mouse_in_Rectangle(e, box_delta_x) Then                         'linkes Viereck
                If TimeLineData_x(TL_x) < 0 Then
                    TimeLineData(TL_x) = HScrollBar1.Value
                ElseIf Not (fft_on) And (TimeLineData_x(TL_2) < 0) Then
                    TimeLineData(TL_2) = HScrollBar1.Value
                End If
            ElseIf Mouse_in_Rectangle(e, PictureBox1.Width - box_delta_x) Then 'rechtes Viereck
                If TimeLineData_x(TL_x) > PictureBox1.Width - (2 * box_delta_x) Then
                    TimeLineData(TL_x) = (PictureBox1.Width - (2 * box_delta_x)) * varDIV_loop / delta_x1 + HScrollBar1.Value
                ElseIf Not (fft_on) And (TimeLineData_x(TL_2) > PictureBox1.Width - (2 * box_delta_x)) Then
                    TimeLineData(TL_2) = (PictureBox1.Width - (2 * box_delta_x)) * varDIV_loop / delta_x1 + HScrollBar1.Value
                End If
            End If
            CalculateTime()
            'If Switch_hold Then
            Write_Spectrum() ' auch bei geringer Wiederholrate ZeitlinienVerschiebung mglichst ruckelfrei darstellen
            'End If
        End If
    End Sub
    Function Mouse_in_Rectangle(ByVal e As System.Windows.Forms.MouseEventArgs, ByVal x_mid_Rect As Decimal) As Boolean
        'Innerhalb der oberen und unteren Line                   und der linken und rechten Linie des Vierecks?
        Return (e.Y >= box_delta_y - 6 And e.Y <= box_delta_y + 1 And e.X - 4 <= x_mid_Rect And e.X + 3 >= x_mid_Rect)
    End Function
    Function TimeLineData_x(ByVal TL_x As Decimal) As Decimal
        Return ((TimeLineData(TL_x) - HScrollBar1.Value) * delta_x1 / varDIV_loop)
    End Function

    Private Sub PictureBox1_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseMove
        If TimeLineData(0) > TL_off Then
            If e.X < box_delta_x Then                         'linker Rand erreicht?
                TimeLineData(TimeLineData(0)) = HScrollBar1.Value
            ElseIf e.X > PictureBox1.Width - box_delta_x Then 'rechter Rand erreicht?
                TimeLineData(TimeLineData(0)) = (PictureBox1.Width - (2 * box_delta_x)) * varDIV_loop / delta_x1 + HScrollBar1.Value
            Else                                              'innerhalb des Bereiches
                TimeLineData(TimeLineData(0)) = ((e.X - box_delta_x) * varDIV_loop / delta_x1) + HScrollBar1.Value
            End If
            CalculateTime()
            'If Switch_hold Then
            Write_Spectrum() ' auch bei geringer Wiederholrate ZeitlinienVerschiebung mglichst ruckelfrei darstellen
            'End If
        End If
    End Sub

    Private Sub PictureBox1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
        If visibleTimeL And e.Button = Windows.Forms.MouseButtons.Left Then
            If e.Y >= box_delta_y - 6 And e.Y <= Me.PictureBox1.Height - box_delta_y + 2 Then 'Innerhalb der oberen und unteren Line?
                If fft_on Then
                    If TLx_MouseDown(e, TL_3) Then
                        TimeLineData(0) = TL_3
                    End If
                Else
                    If TLx_MouseDown(e, TL_1) Then
                        TimeLineData(0) = TL_1
                    ElseIf TLx_MouseDown(e, TL_2) Then
                        TimeLineData(0) = TL_2
                    End If
                End If
            End If
        End If
    End Sub
    Function TLx_MouseDown(ByVal e As System.Windows.Forms.MouseEventArgs, ByVal TL_x As Decimal) As Boolean
        Dim tmpTimeLineData As Decimal = (TimeLineData(TL_x) - HScrollBar1.Value) * delta_x1 / varDIV_loop + box_delta_x
        Return (e.X - 3 <= tmpTimeLineData And e.X + 2 >= tmpTimeLineData) Or Mouse_in_Rectangle(e, tmpTimeLineData)
    End Function

    Private Sub PictureBox1_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseUp
        If e.Button = Windows.Forms.MouseButtons.Left Then TimeLineData(0) = TL_off
    End Sub

    Private Sub Zeitlinien_MenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Zeitlinien_MenuItem.Click
        If visibleTimeL Then
            visibleTimeL = False
            Zeitlinien_MenuItem.Checked = False
            TextBox_Cu_Zeit.Text = ""
            TextBox_Cu_Frequenz.Text = ""
            GroupBox_Cursor.Visible = False
        Else
            visibleTimeL = True
            Zeitlinien_MenuItem.Checked = True
            GroupBox_Cursor.Visible = True
            CalculateTime()
        End If
        If Switch_hold Then Write_Spectrum()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If SerialPort1.IsOpen = True Then
            Try
                SerialPort1.Write("GET")
                SerialPort1.Write(Chr(13))
            Catch
                Exit Try
            End Try
        End If
        Write_Spectrum()
    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Dim Byte_RX_Count As Long
        Dim p As Byte
        Dim header_b0, header_b1, header_b2, header_b3 As Byte
        Dim header_hold As Boolean
        Dim tmp_p As Byte = 0
        Dim exit_count As Integer

        header_b1 = 1
        header_b2 = 1
        header_b3 = 1
        header_hold = False
        If Not (hold) Then
            Do
                header_b0 = header_b1
                header_b1 = header_b2
                header_b2 = header_b3
                exit_count = exit_end
                Try
                    While (SerialPort1.BytesToRead = 0) And (exit_count > 0)
                        exit_count -= 1
                    End While
                Catch
                    Exit Sub
                End Try
                Try
                    header_b3 = SerialPort1.ReadByte()
                Catch
                    Exit Sub
                End Try
            Loop Until (header_b0 = 0) And ((header_b1 = 0 And header_b2 = 255 And header_b3 = 240) Or _
                                            is_header_hold(header_b1, header_b2, header_b3, header_hold))
            TrPoint = read_Tr_Point()
            For Byte_RX_Count = 0 To (RX_Count)
                exit_count = exit_end
                Try
                    While (SerialPort1.BytesToRead = 0) And (exit_count > 0)
                        exit_count -= 1
                    End While
                Catch
                    Exit For
                End Try
                Try
                    Data(Byte_RX_Count) = SerialPort1.ReadByte()
                Catch
                    Exit For
                End Try
            Next
            If HScrollBar1.Maximum > 0 And TrPoint > HScrollBar1.Maximum Then ' kommt nur bei Fehler whrend der seriellen
                TrPoint = HScrollBar1.Maximum - 2 ' Datenbertragung vor - muss aber behandelt
            End If                                ' werden
            If Switch_hold Then
                If header_hold Then
                    hold = True
                    Button_Hold.BackColor = Color.Yellow
                    readDataHold = True
                    TrPoint = TrPoint + 2 ' 2 - rs232-bertragung erst kurz nach Triggerung
                    GroupBox_TriggerDelayVisible(0)
                    GroupBox_Y_PosVisible(0)
                End If
            End If
        Else
            If readDataHold Then ' macht das Einlesen HoldRam noch etwas sicherer
                ProgressVisible(1)
                Do
                    header_b0 = header_b1
                    header_b1 = header_b2
                    header_b2 = header_b3
                    exit_count = exit_end
                    Try
                        While (SerialPort1.BytesToRead = 0) And (exit_count > 0)
                            exit_count -= 1
                        End While
                    Catch
                        Exit Sub
                    End Try
                    Try
                        header_b3 = SerialPort1.ReadByte()
                    Catch
                        Exit Sub
                    End Try
                Loop Until header_b0 = 0 And header_b1 = 255 And header_b2 = 254 And header_b3 = 240
                read_Tr_Point()                       ' header vst. lesen
                For Byte_RX_Count = 0 To RAM_size - 5 ' rs232-bertragung relativ unsicher
                    exit_count = exit_end
                    Try
                        While (SerialPort1.BytesToRead = 0) And (exit_count > 0)
                            exit_count -= 1
                        End While
                    Catch
                        Exit For
                    End Try
                    Try
                        Data(Byte_RX_Count) = SerialPort1.ReadByte()
                    Catch
                        Exit For
                    End Try
                    p = Byte_RX_Count * 100 \ (RAM_size + 1) ' sonst bremst ProgressBar
                    If p > tmp_p Then                        ' das Einlesen zu sehr aus
                        tmp_p = p                            ' so um ca. Faktor 2
                        set_Progress(p)                      ' schneller
                    End If
                Next
                ProgressVisible(0)
                If Not (trigger_prev) Then TrPoint = TrPoint + (DIV_loop + 1) * trigger_delay
                HScrollBarValue(TrPoint)                     ' im TriggerEreignis mit Darstellung beginnen 
                HScrollBarVisible(1)
                TimeLineData(TL_1) = TrPoint - 1
                TimeLineData(TL_2) = TrPoint - 1
                TrPoint = TrPoint + (DIV_loop + 1) * trigger_delay * trigger_vz
                If Not (trigger_ram) Then
                    TrPoint = 0
                    GroupBox_SpurVisible(0)
                End If
                readDataHold = False
                If DIV_loop > 0 Then
                    GroupBox_DehnenVisible(1)
                    TrackBar_DehnenMax(DIV_loop + 1)
                    TrackBar_DehnenValue(DIV_loop + 1)
                    varDIV_loop = DIV_loop + 1
                    TP_DIV_loop = DIV_loop + 1
                End If
            End If
        End If
    End Sub
    Function is_header_hold(ByVal b1 As Byte, ByVal b2 As Byte, ByVal b3 As Byte, ByRef hdr_hold As Boolean) As Boolean
        If b1 = 255 And b2 = 0 And b3 = 240 Then hdr_hold = True
        Return (hdr_hold)
    End Function
    Function read_Tr_Point() As Integer
        Dim Trp(1) As Byte
        Dim i As Byte
        Dim tmpTrPoint As Integer
        Dim exit_count As Integer

        For i = 0 To 1
            exit_count = exit_end
            Try
                While (SerialPort1.BytesToRead = 0) And (exit_count > 0)
                    exit_count -= 1
                End While
            Catch
                Exit Try
            End Try
            Try
                Trp(i) = SerialPort1.ReadByte()
            Catch
                Exit Try
            End Try
        Next
        tmpTrPoint = Trp(1)                     ' BitSchieben von Array-Inhalten nicht mglich
        tmpTrPoint = Trp(0) + (tmpTrPoint << 8) ' Triggerpunkt besteht aus msb und lsb
        Return (tmpTrPoint)
    End Function

    Private Sub set_Progress(ByVal x As Decimal)
        If Me.ProgressBar1.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf set_Progress)
            Me.Invoke(d, New Object() {x})
        Else
            Me.ProgressBar1.Value = x
        End If
    End Sub
    Private Sub ProgressVisible(ByVal x As Decimal)
        If Me.ProgressBar1.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf ProgressVisible)
            Me.Invoke(d, New Object() {x})
        Else
            Me.ProgressBar1.Visible = x
        End If
    End Sub
    Private Sub HScrollBarValue(ByVal x As Decimal)
        If Me.HScrollBar1.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf HScrollBarValue)
            Me.Invoke(d, New Object() {x})
        Else
            Me.HScrollBar1.Value = x
        End If
    End Sub
    Private Sub HScrollBarVisible(ByVal x As Decimal)
        If Me.HScrollBar1.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf HScrollBarVisible)
            Me.Invoke(d, New Object() {x})
        Else
            Me.HScrollBar1.Visible = x
        End If
    End Sub
    Private Sub GroupBox_Y_PosVisible(ByVal x As Decimal)
        If Me.GroupBox_Y_Pos.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf GroupBox_Y_PosVisible)
            Me.Invoke(d, New Object() {x})
        Else
            Me.GroupBox_Y_Pos.Visible = x
        End If
    End Sub
    Private Sub GroupBox_TriggerDelayVisible(ByVal x As Decimal)
        If Me.GroupBox_TriggerDelay.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf GroupBox_TriggerDelayVisible)
            Me.Invoke(d, New Object() {x})
        Else
            Me.GroupBox_TriggerDelay.Visible = x
        End If
    End Sub
    Private Sub GroupBox_DehnenVisible(ByVal x As Decimal)
        If Me.GroupBox_Dehnen.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf GroupBox_DehnenVisible)
            Me.Invoke(d, New Object() {x})
        Else
            Me.GroupBox_Dehnen.Visible = x
        End If
    End Sub
    Private Sub TrackBar_DehnenMax(ByVal x As Decimal)
        If Me.TrackBar_Dehnen.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf TrackBar_DehnenMax)
            Me.Invoke(d, New Object() {x})
        Else
            Me.TrackBar_Dehnen.Maximum = x
        End If
    End Sub
    Private Sub TrackBar_DehnenValue(ByVal x As Decimal)
        If Me.TrackBar_Dehnen.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf TrackBar_DehnenValue)
            Me.Invoke(d, New Object() {x})
        Else
            Me.TrackBar_Dehnen.Value = x
        End If
    End Sub
    Private Sub GroupBox_SpurVisible(ByVal x As Decimal)
        If Me.GroupBox_Spur.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf GroupBox_SpurVisible)
            Me.Invoke(d, New Object() {x})
        Else
            Me.GroupBox_Spur.Visible = x
        End If
    End Sub

    Private Sub Button_t_plus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_t_plus.Click
        If (SerialPort1.IsOpen = True) And Not (hold) Then
            If Time_div_set < 15 And (Not (fft_on) Or fft_exp_sampels = 0 Or trigger_ram Or Not (accelerate) Or Time_div_set + 1 < acc_border) Then
                Time_div_set = Time_div_set + 1
                Time_print()
            End If
        End If
    End Sub

    Private Sub Button_t_minus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_t_minus.Click
        If (SerialPort1.IsOpen = True) And Not (hold) Then
            If Time_div_set > 0 Then
                Time_div_set = Time_div_set - 1
                Time_print()
            End If
        End If
    End Sub

    Private Sub Time_print()
        'bei Teiler 1 max RAM-Inhalt 20ns * 1 * 32768 = 655369 ns ca. 655 s
        'innerhalb ca. des halben Speichers wird Triggerflanke ermittelt, so
        'dass im ungnstigen Fall nur die halbe Aufzeichnungszeit fr das Signal
        'zur Verfgung steht. Die Triggerverzgerung beeinflusst diese zustzlich.
        Dim DimResult As String = ""
        Dim Result As Decimal

        Time_Bytes_Print = Const_Time_Bytes_Print(Time_div_set)
        'DIV_loop - Wert fr Softwareschleife der Firmware, nur jedes n-te Byte + 1 wird zum PC bertragen 
        DIV_loop = Const_DIV_loop(Time_div_set)
        'DIV_teiler - programmierbarer Vorteile der Firmware
        DIV_teiler = Const_DIV_teiler(Time_div_set)
        ' Formel fr Dargestellte Zeit pro Div
        ' <Wert Softwareschleife + 1> * <Hardware Vorteiler> * <20ns Zeitbasis bestimmt durch Quarz> * 
        ' <Anzahl dargestellte Sampels in WriteSpectrum> / <Anzahl dargestellter vertikalier Linien>
        'Time_div_set  0  100 ns   ( 1 *       20ns *  60 Sampels / 12 Div =      100ns          ** H)
        'Time_div_set  1  250 ns   ( 1 *       20ns * 150 Sampels / 12 Div =      250ns          ** H)
        'Time_div_set  2  500 ns   ( 1 *       20ns * 300 Sampels / 12 Div =      500ns          ** H)
        'Time_div_set  3    1 s   ( 1 *       20ns * 600 Sampels / 12 Div =     1000ns 1s      ** H)
        'Time_div_set  4    2.5 s ( 3 *       20ns * 500 Sampels / 12 Div =     2500ns 2,5s    ** H)
        'Time_div_set  5    5 s   ( 5 *       20ns * 600 Sampels / 12 Div =     5000ns 5s      ** H)
        'Time_div_set  6   10 s   (10 *       20ns * 600 Sampels / 12 Div =    10000ns 10 s    ** H)
        'bei Teiler 2 max RAM-Inhalt 20ns * 2 * 32768 = 1310720 ns ca. 1,3 ms
        'Time_div_set  7   25 s   (25 *       20ns * 600 Sampels / 12 Div =    25000ns 25 s    ** H)
        '  Teiler bei 25s von 625,11,3 wieder auf 600,24,0 gesetzt, da vorher extrem lange Wiederholrate
        '  (12 * 2 * 20ns * 625 Sampels /12Div = 25000 ns 25 s ** H)
        'bei Teiler 32 max RAM-Inhalt 20ns * 32 * 32768 = 20971520 ns ca. 21 ms
        'Time_div_set  8   50 s   ( 2 *  32 * 20ns * 469 Sampels / 12 Div =    50027ns ca 50 s ** H)
        'Time_div_set  9  100 s   ( 3 *  32 * 20ns * 625 Sampels / 12 Div =   100000ns 100s    ** H)
        'Time_div_set 10  250 s   ( 8 *  32 * 20ns * 586 Sampels / 12 Div =   250027ns ca 250s ** H)
        'Time_div_set 11  500 s   (15 *  32 * 20ns * 625 Sampels / 12 Div =   500000ns 500s    ** H)
        'bei Teiler 256 max RAM-Inhalt 20ns * 256 * 32768 = 167772160 ns ca. 167 ms
        'Time_div_set 12    1 ms   ( 5 * 256 * 20ns * 469 Sampels / 12 Div =  1000533ns ca 1ms   ** H)
        'Time_div_set 13    2.5 ms (10 * 256 * 20ns * 586 Sampels / 12 Div =  2500267ns ca 2.5ms ** H)
        'Time_div_set 14    5 ms   (21 * 256 * 20ns * 558 Sampels / 12 Div =  4999680ns ca 5ms   ** H)
        'Time_div_set 15   10 ms   (39 * 256 * 20ns * 601 Sampels / 12 Div = 10000640ns ca 10ms  ** H)
        Try
            SerialPort1.Write("DIV " + CStr(DIV_teiler) + "," + CStr(DIV_loop))
            SerialPort1.Write(Chr(13))
        Catch
            Exit Try
        End Try
        TP_DIV_loop = DIV_loop + 1

        Result = Teiler(DIV_teiler) * TimeBase * (DIV_loop + 1) * Time_Bytes_Print
        If Not (trigger_ram) Then
            acc_delay = Result \ 1000000 + 1  ' gleich in ms + 1ms wegen Nachkommastellen
            If Time_div_set < acc_border Then ' ab 1ms und top-RAM beschleunigen der Darstellung durch vorzeitiges Beenden RAM-write mglich
                acc_delay = 0                 ' sonst vollstndig RAM beschreiben
                GroupBox_Spur.Visible = False
                Button_Hold.Visible = True
            Else
                GroupBox_Spur.Visible = Not (fft_on)
            End If
            If accelerate Then
                Button_Hold.Visible = Not (acc_delay > 0)
                Try
                    SerialPort1.Write("ACC")
                    SerialPort1.Write(Str(acc_delay))
                    SerialPort1.Write(Chr(13))
                Catch
                    Exit Try
                End Try
            End If
        End If
        'Horizontal div
        TextBox_Horizomtal.Text = CStr(Round(CalculateTimeDim(Result / div_x, DimResult) * 10) / 10) + DimResult  'x * 20ns in Func enthalten
        If fft_on Then
            fft_init_values()
            Write_Spectrum() 'nur fr Frequenzanzeige Cursor bei FFT delta_x1 wird nur bei Write_Spectrum gendert
        End If
        CalculateTime()
    End Sub

    Public Sub fft_init_values()
        fa = 1000000000 / (Teiler(DIV_teiler) * TimeBase)
        If Nfft = 512 Then
            fa = 1000000000 / (Teiler(DIV_teiler) * TimeBase * (DIV_loop + 1))
        Else
            fa = 1000000000 / (Teiler(DIV_teiler) * TimeBase)
        End If
        fn = fa / 2
        df = fa / Nfft
    End Sub

    Private Sub Button_set_AC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_AC.Click
        If Not (hold) Then set_AC()
    End Sub
    Private Sub set_AC()
        If SerialPort1.IsOpen = True Then
            Button_AC.BackColor = Color.LightGreen()
            Button_DC.BackColor = SystemColors.Control
            Try
                SerialPort1.Write("AC")
                SerialPort1.Write(Chr(13))
            Catch
                Exit Try
            End Try
        End If
    End Sub

    Private Sub Button_set_DC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_DC.Click
        If Not (hold) Then set_DC()
    End Sub
    Private Sub set_DC()
        If SerialPort1.IsOpen = True Then
            Button_DC.BackColor = Color.LightGreen()
            Button_AC.BackColor = SystemColors.Control
            Try
                SerialPort1.Write("DC")
                SerialPort1.Write(Chr(13))
            Catch
                Exit Try
            End Try
        End If
    End Sub

    Private Sub TrackBar_YPos_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar_YPos.Scroll
        set_y_pos()
    End Sub
    Private Sub set_y_pos()
        Dim offset As Byte
        If SerialPort1.IsOpen = True Then
            offset = TrackBar_YPos.Value
            Try
                SerialPort1.Write("OFFSET")
                SerialPort1.Write(Str(offset))
                SerialPort1.Write(Chr(13))
            Catch
                Exit Try
            End Try
        End If
    End Sub

    Private Sub Drucken_MenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Drucken_MenuItem.Click
        If PrintDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then PrintDocument1.Print()
    End Sub

    Private Sub TrackBar_Trigger_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar_Trigger.Scroll
        If hold Then TrackBar_Trigger.Value = trigoff
        set_triggeroff()
    End Sub
    Private Sub set_triggeroff()
        If SerialPort1.IsOpen = True Then
            trigoff = TrackBar_Trigger.Value
            Try
                SerialPort1.Write("TRIGOFF")
                SerialPort1.Write(Str(trigoff))
                SerialPort1.Write(Chr(13))
            Catch
                Exit Try
            End Try
        End If
    End Sub

    Private Sub Button_Tr_pos_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Tr_pos.Click
        If Not (Switch_hold) Then set_trigfl()
    End Sub
    Private Sub set_trigfl()
        If SerialPort1.IsOpen = True Then
            Button_Tr_pos.BackColor = Color.LightGreen()
            Button_Tr_neg.BackColor = SystemColors.Control
            TrigPos = True
            Try
                SerialPort1.Write("TRIGFH")
                SerialPort1.Write(Chr(13))
            Catch
                Exit Try
            End Try
        End If
    End Sub

    Private Sub Button_Tr_neg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Tr_neg.Click
        If Not (Switch_hold) Then set_trigfh()
    End Sub
    Private Sub set_trigfh()
        If SerialPort1.IsOpen = True Then
            Button_Tr_neg.BackColor = Color.LightGreen()
            Button_Tr_pos.BackColor = SystemColors.Control
            TrigPos = False
            Try
                SerialPort1.Write("TRIGFL")
                SerialPort1.Write(Chr(13))
            Catch
                Exit Try
            End Try
        End If
    End Sub

    Private Sub TrackBar_Trigger_delay_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar_Trigger_delay.Scroll
        set_trigger_delay()
    End Sub
    Private Sub set_trigger_delay()
        If SerialPort1.IsOpen = True Then
            TimeLineData(TL_1) = TimeLineData(TL_1) + (TrackBar_Trigger_delay.Value - trigger_delay) * trigger_vz
            TimeLineData(TL_2) = TimeLineData(TL_2) + (TrackBar_Trigger_delay.Value - trigger_delay) * trigger_vz
            trigger_delay = TrackBar_Trigger_delay.Value
            Try
                SerialPort1.Write("TRIGDEL")
                SerialPort1.Write(Str(trigger_delay))
                SerialPort1.Write(Chr(13))
            Catch
                Exit Try
            End Try
            If (trigger_delay > 0) Then
                GroupBox_TriggerDelay.ForeColor = Color.Red
            Else
                GroupBox_TriggerDelay.ForeColor = SystemColors.ControlText
            End If
        End If
    End Sub

    Private Sub Button_Tr_prev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Tr_prev.Click
        set_trigger_prev()
    End Sub
    Private Sub set_trigger_prev()
        If SerialPort1.IsOpen = True Then
            If trigger_prev Then
                If sync_plus Then
                    sync_plus = False
                    Button_Tr_prev.ForeColor = SystemColors.ControlText
                    Try
                        SerialPort1.Write("NSYNCP")
                        SerialPort1.Write(Chr(13))
                    Catch
                        Exit Try
                    End Try
                Else
                    sync_plus = True 'nur bei Synchronisation Datenbertragung
                    Button_Tr_prev.ForeColor = Color.Yellow
                    Try
                        SerialPort1.Write("SYNCP")
                        SerialPort1.Write(Chr(13))
                    Catch
                        Exit Try
                    End Try
                End If
            Else
                sync_plus = False
                Button_Tr_prev.ForeColor = SystemColors.ControlText
                Button_Tr_delay.ForeColor = SystemColors.ControlText
                Try
                    SerialPort1.Write("NSYNCP")
                    SerialPort1.Write(Chr(13))
                Catch
                    Exit Try
                End Try
                trigger_prev = True
                trigger_vz = 1
            End If
            Button_Tr_prev.BackColor = Color.LightGreen()
            Button_Tr_delay.BackColor = SystemColors.Control
            Try
                SerialPort1.Write("TRPREV")
                SerialPort1.Write(Chr(13))
            Catch
                Exit Try
            End Try
        End If
    End Sub

    Private Sub Button_Tr_delay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Tr_delay.Click
        set_trigger_del()
    End Sub
    Private Sub set_trigger_del()
        If SerialPort1.IsOpen = True Then
            If Not (trigger_prev) Then
                If sync_plus Then
                    sync_plus = False
                    Button_Tr_delay.ForeColor = SystemColors.ControlText
                    Try
                        SerialPort1.Write("NSYNCP")
                        SerialPort1.Write(Chr(13))
                    Catch
                        Exit Try
                    End Try
                Else
                    sync_plus = True 'nur bei Synchronisation Datenbertragung
                    Button_Tr_delay.ForeColor = Color.Yellow
                    Try
                        SerialPort1.Write("SYNCP")
                        SerialPort1.Write(Chr(13))
                    Catch
                        Exit Try
                    End Try
                End If
            Else
                sync_plus = False
                Button_Tr_delay.ForeColor = SystemColors.ControlText
                Button_Tr_prev.ForeColor = SystemColors.ControlText
                Try
                    SerialPort1.Write("NSYNCP")
                    SerialPort1.Write(Chr(13))
                Catch
                    Exit Try
                End Try
                trigger_prev = False
                trigger_vz = -1
            End If
            Button_Tr_delay.BackColor = Color.LightGreen()
            Button_Tr_prev.BackColor = SystemColors.Control
            Try
                SerialPort1.Write("TRDEL")
                SerialPort1.Write(Chr(13))
            Catch
                Exit Try
            End Try
        End If
    End Sub

    Private Sub Button_Hold_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Hold.Click
        If Not fft_on Then set_hold()
    End Sub
    Private Sub set_hold()
        If SerialPort1.IsOpen = True Then
            If Switch_hold Then
                Switch_hold = False
                hold = False
                varDIV_loop = 1        'so kann in Write_Spectrum() gleiches 'paint data line verwendet werden
                HScrollBar1.Value = 0  'so kann in Write_Spectrum() gleiches 'paint data line verwendet werden
                TP_DIV_loop = DIV_loop + 1
                Time_print()
                Button_Hold.BackColor = SystemColors.Control
                HScrollBar1.Visible = False
                GroupBox_Dehnen.Visible = False
                GroupBox_Dehnen.ForeColor = SystemColors.ControlText
                If trigger_ram Then GroupBox_TriggerDelay.Visible = True
                GroupBox_Y_Pos.Visible = True
                TimeLineData(TL_1) = 0
                TimeLineData(TL_2) = 0
                If Not (sync_plus) Then
                    sync_plus = False 'nur bei Synchronisation Datenbertragung
                    Try
                        SerialPort1.Write("NSYNCP")
                        SerialPort1.Write(Chr(13))
                    Catch
                        Exit Try
                    End Try
                End If
                Try
                    SerialPort1.Write("NHOLD")
                    SerialPort1.Write(Chr(13))
                Catch
                    Exit Try
                End Try
                Button_Hold.BackColor = SystemColors.Control
            Else
                Switch_hold = True
                Button_Hold.BackColor = Color.LightGreen()
                HScrollBar1.Maximum = RAM_size - (((Time_Bytes_Print + 1) * (DIV_loop + 1)) - (DIV_loop + 1)) - 11 'etwas weniger darstellen als mglich
                Try
                    SerialPort1.Write("SYNCP") 'bei Hold immer sync_plus verwenden, aber nicht merken
                    SerialPort1.Write(Chr(13))
                    SerialPort1.Write("HOLD")
                    SerialPort1.Write(Chr(13))
                    SerialPort1.Write("HOLDRAM")
                    SerialPort1.Write(Chr(13))
                Catch
                    Exit Try
                End Try
            End If
        End If
    End Sub

    Private Sub Button_TrMode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_TrMode.Click
        set_TrMode()
    End Sub
    Private Sub set_TrMode()
        If SerialPort1.IsOpen = True Then
            If Not (Switch_hold) And Not (fft_on) Then
                If trigger_ram Then
                    trigger_ram = False
                    Button_TrMode.Text = "Top"
                    txt_ToolTip_RAM_top()
                    GroupBox_TriggerDelay.Visible = False
                    acc_delay = 0
                    If Time_div_set >= acc_border Then GroupBox_Spur.Visible = True
                    Try
                        SerialPort1.Write("ACC")
                        SerialPort1.Write(acc_delay)
                        SerialPort1.Write(Chr(13))
                        SerialPort1.Write("TRTRAM")
                        SerialPort1.Write(Chr(13))
                    Catch
                        Exit Try
                    End Try
                Else
                    trigger_ram = True
                    accelerate = False
                    GroupBox_Spur.Visible = False
                    Button_TrMode.Text = "RAM"
                    GroupBox_TriggerDelay.Visible = True
                    Button_Hold.Visible = True
                    Button_acc.Text = "slow"
                    txt_ToolTip_RAM()
                    txt_ToolTip_slow()
                    Try
                        SerialPort1.Write("TRRAM")
                        SerialPort1.Write(Chr(13))
                    Catch
                        Exit Try
                    End Try
                End If
            End If
            Try
                SerialPort1.DiscardInBuffer()
            Catch
                Exit Try
            End Try
        End If
    End Sub

    Private Sub Button_acc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_acc.Click
        set_acc()
    End Sub
    Private Sub set_acc()
        If SerialPort1.IsOpen = True Then
            If accelerate Then
                accelerate = False
                acc_delay = 0
                Button_acc.Text = "slow"
                Button_Hold.Visible = True
                txt_ToolTip_slow()
                FFT_MenuItem.Enabled = True
                Try
                    SerialPort1.Write("ACC")
                    SerialPort1.Write(Str(acc_delay))
                    SerialPort1.Write(Chr(13))
                Catch
                    Exit Try
                End Try
            Else
                accelerate = True
                If Time_div_set >= acc_border Then
                    Button_Hold.Visible = False
                    acc_delay = Teiler(DIV_teiler) * TimeBase * (DIV_loop + 1) * Time_Bytes_Print \ 1000000 + 1 ' gleich in ms + 1ms wegen Nachkommastellen
                    Button_acc.Text = "acc"
                    txt_ToolTip_acc()
                    FFT_MenuItem.Enabled = False
                    Try
                        SerialPort1.Write("ACC")
                        SerialPort1.Write(Str(acc_delay))
                        SerialPort1.Write(Chr(13))
                    Catch
                        Exit Try
                    End Try
                End If
            End If
            Try
                SerialPort1.DiscardInBuffer()
            Catch
            End Try
        End If
    End Sub

    Private Sub txt_ToolTip_RAM()
        ToolTip_RAM.SetToolTip(Me.Button_TrMode, "Triggerpunkt" + vbCrLf + "im RAM-Bereich")
    End Sub
    Private Sub txt_ToolTip_RAM_top()
        ToolTip_RAM.SetToolTip(Me.Button_TrMode, "Triggerpunkt" + vbCrLf + "am RAM-Anfang")
    End Sub
    Private Sub txt_ToolTip_acc()
        ToolTip_acc.SetToolTip(Me.Button_acc, "RAM schreiben" + vbCrLf + "wird vozeitig" + vbCrLf + "abgebrochen." + vbCrLf + "Nach 12...120 ms")
    End Sub
    Private Sub txt_ToolTip_slow()
        ToolTip_acc.SetToolTip(Me.Button_acc, "ganzer RAM-Bereich" + vbCrLf + "genutzt" + vbCrLf + "Hold mglich")
    End Sub

    Public Sub visible_ToolTip(ByVal tmpToolTip As Boolean)
        ToolTip_RAM.Active = tmpToolTip
        ToolTip_acc.Active = tmpToolTip
    End Sub

    Private Sub FFT_MenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FFT_MenuItem.Click
        If acc_delay = 0 Or Not (accelerate) Or fft_exp_sampels = 0 Then set_fft()
    End Sub
    Public Sub set_fft()
        Dim tmp_fft_exp_sampels As Byte

        If Not (Switch_hold) Then
            If fft_on Then
                fft_on = False
                HScrollBar1.Value = 0
                GroupBox_fft_Dehnen.Visible = False
                HScrollBar1.Visible = False
                If trigger_ram Then
                    GroupBox_TriggerDelay.Visible = True
                Else
                    If acc_border <= Time_div_set Then GroupBox_Spur.Visible = True
                End If
                GroupBox_Y_Pos.Visible = True
                TextBox_Cu_Zeit.Visible = True
                FFT_MenuItem.Checked = False
                RX_Count = c_RX_Count - 1
                tmp_fft_exp_sampels = 0 ' in Firmware send_Data wieder mit loop
            Else
                fft_on = True
                GroupBox_TriggerDelay.Visible = False
                GroupBox_Y_Pos.Visible = False
                GroupBox_Spur.Visible = False
                GroupBox_fft_Dehnen.Visible = TrackBar_fft_Dehnen.Maximum > 1 ' entspricht If TrackBar_fft_Dehnen.Maximum > 1
                HScrollBar1.Maximum = N05fft - N05fft \ fft_Dehnen_Value + 1
                HScrollBar1.Visible = (TrackBar_fft_Dehnen.Maximum > 1) And (fft_Dehnen_Value > 1)
                TextBox_Cu_Zeit.Visible = False
                FFT_MenuItem.Checked = True
                TextBox_Cu_Zeit.Text = ""
                fft_init_values()
                If Nfft = 512 Then RX_Count = c_RX_Count - 1 Else RX_Count = Nfft - 1
                tmp_fft_exp_sampels = fft_exp_sampels
            End If
            Try
                SerialPort1.Write("FFT")
                SerialPort1.Write(Str(tmp_fft_exp_sampels))
                SerialPort1.Write(Chr(13))
            Catch
                Exit Try
            End Try
            CalculateTime()
        End If
    End Sub

    Private Sub TrackBar_fft_Dehnen_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar_fft_Dehnen.Scroll
        fft_Dehnen_Value = TrackBar_fft_Dehnen.Maximum + 1 - TrackBar_fft_Dehnen.Value ' nur umgekehrte Wirkung von TrackBar
        If fft_Dehnen_Value > 1 Then
            HScrollBar1.Maximum = N05fft - N05fft \ fft_Dehnen_Value + 1
            HScrollBar1.Visible = True
        Else
            HScrollBar1.Value = 0
            HScrollBar1.Visible = False
        End If
    End Sub

    Private Sub HScrollBar1_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar1.Scroll
        Write_Spectrum()
    End Sub

    Private Sub TrackBar_Dehnen_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar_Dehnen.Scroll
        Dim DimResult As String = ""
        Dim Result As Decimal
        varDIV_loop = TrackBar_Dehnen.Value
        TP_DIV_loop = varDIV_loop
        HScrollBar1.Maximum = RAM_size - (((Time_Bytes_Print + 1) * (varDIV_loop)) - (varDIV_loop)) - 11 ' -11 etwas weniger Scrollen als max. mglich, falls mal nicht RAM vst. bertragen
        If (varDIV_loop < DIV_loop + 1) Then
            GroupBox_Dehnen.ForeColor = Color.Red
        Else
            GroupBox_Dehnen.ForeColor = SystemColors.ControlText
        End If
        Result = CalculateTimeDim(Teiler(DIV_teiler) * TimeBase * varDIV_loop * Time_Bytes_Print / div_x, DimResult) 'x * 20ns in Func enthalten
        TextBox_Horizomtal.Text = FormatTimeDim(Result, DimResult)
        CalculateTime()
        Write_Spectrum()
    End Sub

    Private Sub Messpunkte_MenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Messpunkte_MenuItem.Click
        If visibleMessPkt Then
            visibleMessPkt = False
            Messpunkte_MenuItem.Checked = False
        Else
            visibleMessPkt = True
            Messpunkte_MenuItem.Checked = True
        End If
        If Switch_hold Then
            Write_Spectrum()
        End If
    End Sub

    Private Sub CalculateTime()
        Dim pTime As Decimal
        Dim Result As Decimal
        Dim DimResult As String = ""
        If visibleTimeL Then
            If fft_on Then
                'TextBox_Cu_Frequenz.Text = FormatFrequenz(Round((TimeLineData(TL_3)) * 100) / 100 * df)
                TextBox_Cu_Frequenz.Text = FormatFrequenz(Round((TimeLineData(TL_3)) * 10000) / 10000 * df)
            Else
                pTime = Abs(TimeLineData(TL_1) - TimeLineData(TL_2)) ' DIV_loop + 1 ist hier in VB2008 Software  x * 20ns in Func enthalten
                If Not (hold) Then
                    pTime = pTime * (DIV_loop + 1)   ' DIV_loop + 1 hineinrechnen, da in Firmware x * 20ns in Function enthalten
                End If
                pTime = pTime * Teiler(DIV_teiler) * TimeBase
                Result = CalculateTimeDim(pTime, DimResult)
                TextBox_Cu_Zeit.Text = FormatTimeDim(Result, DimResult)
                Result = CalculateFrequDim(pTime, DimResult)
                TextBox_Cu_Frequenz.Text = FormatTimeDim(Result, DimResult)
            End If
        End If
    End Sub

    Private Function CalculateTimeDim(ByVal Result As Decimal, ByRef DimResult As String) As Decimal
        If Result < 1000 Then
            DimResult = " ns"
        Else
            Result = Result / 1000
            If Result < 1000 Then
                DimResult = " s"
            Else
                Result = Result / 1000
                DimResult = " ms"
            End If
        End If
        Return (Result)
    End Function

    Private Function CalculateFrequDim(ByVal Result As Decimal, ByRef DimResult As String) As Decimal
        If Result <> 0 Then
            Result = 1000 / Result
            If Result >= 1 Then
                DimResult = " MHz"
            Else
                Result = Result * 1000
                If Result >= 1 Then
                    DimResult = " KHz"
                Else
                    Result = Result * 1000
                    DimResult = " Hz"
                End If
            End If
        Else
            Result = 0
            DimResult = ""
        End If
        Return (Result)
    End Function

    Private Function FormatTimeDim(ByVal Time As Decimal, ByVal DimResult As String) As String
        Dim Result As String = ""
        If Time >= 100 Then
            Result = Format(Time + 0.0005, "0.00") + DimResult
            'ElseIf Time >= 10 Then
            'Result = Format(Time + 0.000005, "0.000") + DimResult
        ElseIf Time >= 1 Then
            Result = Format(Time + 0.000005, "0.000") + DimResult
        End If
        Return (Result)
    End Function

    Private Sub Form1_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        CalculateTime()
        Write_Spectrum()
    End Sub

    Private Sub Form1_Move(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Move
        CalculateTime()
        Write_Spectrum()
    End Sub

    Private Sub Beenden_MenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Beenden_MenuItem.Click
        Me.Close()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Timer1.Stop()
        WriteRegEntry("Settings", "Time-div", Time_div_set)
        WriteRegEntry("Settings", "Triggervalue", TrackBar_Trigger.Value)
        WriteRegEntry("Settings", "Y-Position", TrackBar_YPos.Value)
    End Sub

    Private Sub Optionen_MenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Optionen_MenuItem.Click
        Optionen.TextBox_Wiederholrate.Text = Timer1.Interval
        Optionen.ComboBox_FFT_Samples.Text = 512 << fft_exp_sampels
        If Not (Uss_Visible) Then
            Optionen.TextBox_Uss.Text = "0"
        Else
            Optionen.TextBox_Uss.Text = Uss_corr
        End If
        Optionen.TextBox_UssGraphik.Text = UssGr_corr
        Optionen.CheckBox_Hinweise.Checked = ToolTip
        Optionen.Show()
    End Sub

    Private Sub Farben_MenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Farben_MenuItem.Click
        Farben.Show()
    End Sub

End Class

